## watchman 4.9.0

=== winbuild/Makefile ===
!IF "$(APPVEYOR_REPO_COMMIT)" != ""
BUILD_INFO="-DWATCHMAN_BUILD_INFO=""$(APPVEYOR_REPO_COMMIT) $(APPVEYOR_REPO_COMMIT_TIMESTAMP)"""
!ENDIF

# Strict compilation, but suppress deprecation of POSIX and a couple of
# warnings that get generated by the system headers
#PEDANTIC=/Wall /wd4555 /wd4221 /wd4210 /wd4152 /wd4204 /wd4127 /wd4996 /wd4820 /wd4255 /wd4668 /wd4201 /wd4232 /wd4710 /wd4214
CFLAGS=/nologo /MP /WX /Zi /Zo /Oi /MT /I $(MAKEDIR)\winbuild /I $(MAKEDIR) /I $(MAKEDIR)\thirdparty\jansson /FS $(BUILD_INFO)

CXXFLAGS=$(CFLAGS) /EHsc
LIBS=shlwapi.lib advapi32.lib dbghelp.lib
LINKER=link /nologo /out:$@ /debug /incremental:no /opt:ref /opt:icf /pdb:$(@:.exe=.pdb)

JSON_SRCS=\
	thirdparty\jansson\dump.cpp \
	thirdparty\jansson\error.cpp \
	thirdparty\jansson\load.cpp \
	thirdparty\jansson\memory.cpp \
	thirdparty\jansson\pack_unpack.cpp \
	thirdparty\jansson\strbuffer.cpp \
	thirdparty\jansson\strconv.cpp \
	thirdparty\jansson\utf.cpp \
	thirdparty\jansson\value.cpp

SRCS_C=\
	thirdparty\wildmatch\wildmatch.c \

SRCS_CPP=\
	$(JSON_SRCS) \
	ChildProcess.cpp \
	ContentHash.cpp \
	CookieSync.cpp \
	FileDescriptor.cpp \
	FileInformation.cpp \
	InMemoryView.cpp \
	Pipe.cpp \
	PubSub.cpp \
	ThreadPool.cpp \
	QueryableView.cpp \
	winbuild\errmap.cpp \
	winbuild\pathmap.cpp \
	winbuild\mkdir.cpp \
	winbuild\dir.cpp \
	winbuild\asprintf.cpp \
	winbuild\hostname.cpp \
	winbuild\time.cpp \
	winbuild\backtrace.cpp \
	winbuild\getopt_long.cpp \
	winbuild\posix_spawn.cpp \
	ignore.cpp \
	spawn.cpp \
	opt.cpp \
	cfg.cpp \
	clockspec.cpp \
	checksock.cpp \
	error_category.cpp \
	fstype.cpp     \
	log.cpp        \
	json.cpp       \
	bser.cpp       \
	expflags.cpp   \
	hash.cpp       \
	ioprio.cpp     \
	opendir.cpp    \
	pending.cpp    \
	perf.cpp       \
	stream.cpp     \
	stream_win.cpp \
	stream_stdout.cpp \
	cmds\find.cpp     \
	cmds\info.cpp     \
	cmds\log.cpp      \
	cmds\query.cpp    \
	cmds\since.cpp    \
	cmds\reg.cpp      \
	cmds\state.cpp    \
	cmds\subscribe.cpp    \
	cmds\trigger.cpp  \
	cmds\watch.cpp    \
	cmds\debug.cpp    \
	query\base.cpp       \
	query\parse.cpp      \
	query\dirname.cpp    \
	query\eval.cpp       \
	query\glob.cpp       \
	query\type.cpp       \
	query\suffix.cpp     \
	query\match.cpp      \
	query\pcre.cpp       \
	query\name.cpp       \
	query\fieldlist.cpp  \
	query\intcompare.cpp  \
	query\since.cpp      \
	query\empty.cpp      \
	watcher\auto.cpp \
	watcher\win32.cpp \
	listener.cpp   \
	listener-user.cpp   \
	clientmode.cpp \
	main.cpp       \
	root\ageout.cpp       \
	root\crawler.cpp       \
	root\dir.cpp       \
	root\file.cpp       \
	root\init.cpp       \
	root\iothread.cpp       \
	root\notifythread.cpp       \
	root\poison.cpp       \
	root\reap.cpp       \
	root\resolve.cpp       \
	root\stat.cpp       \
	root\symlink.cpp       \
	root\sync.cpp       \
	root\threading.cpp       \
	root\vcs.cpp       \
	root\warnerr.cpp       \
	root\watchlist.cpp       \
	scm\Mercurial.cpp \
	scm\SCM.cpp \
	state.cpp      \
	string.cpp     \
	time.cpp

TEST_SRCS_C=\
	thirdparty\wildmatch\wildmatch.c

TEST_SRCS_CPP=\
	thirdparty\tap.cpp \
	winbuild\asprintf.cpp \
	winbuild\time.cpp \
	winbuild\backtrace.cpp \
	winbuild\errmap.cpp \
	$(JSON_SRCS)

TEST_DIR_SRCS=

TEST_DIR_SRCS_CPP=\
	tests\art_test.cpp \
	tests\bser.cpp \
	tests\childproc.cpp \
	tests\ResultTest.cpp \
	tests\ignore_test.cpp \
	tests\log_stub.cpp \
	tests\log.cpp

OBJS=$(SRCS_CPP:.cpp=.obj) $(SRCS_C:.c=.obj)
TEST_OBJS=$(TEST_SRCS_CPP:.cpp=.obj) $(TEST_SRCS_C:.c=.obj)
TEST_DIR_OBJS=$(TEST_DIR_SRCS:.c=.obj) $(TEST_DIR_SRCS_CPP:.cpp=.obj)
TESTS=tests\log.exe tests\bser.exe tests\wildmatch_test.exe \
			tests\art.exe tests\ignore.exe tests\pending.exe \
			tests\string.exe tests\childproc.exe tests\result.exe \
			tests\future.exe tests\cache.exe

{}.cpp{}.obj::
	@echo CXX $<
	$(CC) $(CXXFLAGS) $(PEDANTIC) /Fo:.\ /c $<

{tests}.c{tests}.obj::
	@echo CC $<
	$(CC) $(CFLAGS) $(PEDANTIC) /Fo:tests\ /c $<

{tests}.cpp{tests}.obj::
	@echo CXX $<
	$(CC) $(CXXFLAGS) $(PEDANTIC) /Fo:tests\ /c $<

{winbuild}.cpp{winbuild}.obj::
	@echo CXX $<
	$(CC) $(CXXFLAGS) $(PEDANTIC) /Fo:winbuild\ /c $<

{cmds}.cpp{cmds}.obj::
	@echo CXX $<
	$(CC) $(CXXFLAGS) $(PEDANTIC) /Fo:cmds\ /c $<

{query}.cpp{query}.obj::
	@echo CXX $<
	$(CC) $(CXXFLAGS) $(PEDANTIC) /Fo:query\ /c $<

{watcher}.cpp{watcher}.obj::
	@echo CXX $<
	$(CC) $(CXXFLAGS) $(PEDANTIC) /Fo:watcher\ /c $<

{root}.cpp{root}.obj::
	@echo CXX $<
	$(CC) $(CXXFLAGS) $(PEDANTIC) /Fo:root\ /c $<

{scm}.cpp{scm}.obj::
	@echo CXX $<
	$(CC) $(CXXFLAGS) $(PEDANTIC) /Fo:scm\ /c $<

{thirdparty\wildmatch}.c{thirdparty\wildmatch}.obj::
	@echo CC $<
	$(CC) $(CFLAGS) /Fo:thirdparty\wildmatch\ /c $<

{thirdparty\jansson}.cpp{thirdparty\jansson}.obj::
	@echo CXX $<
	$(CC) $(CXXFLAGS) /Fo:thirdparty\jansson\ /c $<

{thirdparty}.cpp{thirdparty}.obj::
	@echo CXX $<
	$(CC) $(CXXFLAGS) /Fo:thirdparty\ /c $<

all: remove-config-h watchman.exe build-tests susres.exe

remove-config-h:
	-del config.h watchman

# problems with vcvarsall.bat? http://stackoverflow.com/a/10558328/149111
# The Visual Studio 2015 image on AppVeyor includes Visual Studio for Python
# and that MUST be used to compile the python extension.  The build system
# that we use locally does not have this installed, so we use our installed
# compiler.  To allow AppVeyor to use the python specific compiler without
# getting confused by our 2015 environment, we clear out the compiler
# related environment when we're running in AppVeyor.
py-build:
	if defined APPVEYOR set INCLUDE=
	if defined APPVEYOR set LIB=
	if defined APPVEYOR set LIBPATH=
	if defined APPVEYOR set VS90COMNTOOLS=
	cd python && python ./setup.py clean build_py -c -d . build_ext -i

py-integration: py-build
	python -u runtests.py --keep-if-fail --concurrency=1

# helper for suspending/resuming a target process
susres.exe: winbuild\susres.cpp
	$(CC) /Fesusres.exe winbuild\susres.cpp

integration: build-tests susres.exe py-integration

integration-win7: build-tests susres.exe py-build
	python -u runtests.py --keep-if-fail --concurrency=1 --win7

build-tests: $(TESTS)

watchman.exe: $(OBJS)
	@echo LINK $@
	$(LINKER) $(OBJS) $(LIBS)

tests\argv.exe: tests\argv.obj $(TEST_OBJS) \
	tests\log_stub.obj \
	PubSub.obj \
	argv.obj \
	string.obj \
	hash.obj \
	log.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\art.exe: tests\art_test.obj $(TEST_OBJS) \
  	log.obj \
	tests\log_stub.obj \
	PubSub.obj \
	string.obj \
	hash.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\ignore.exe: tests\ignore_test.obj $(TEST_OBJS) \
		hash.obj \
		ignore.obj \
		string.obj \
		log.obj \
		PubSub.obj \
		tests\log_stub.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\string.exe: tests\string_test.obj $(TEST_OBJS) \
		hash.obj \
		string.obj \
		log.obj \
		PubSub.obj \
		tests\log_stub.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\pending.exe: tests\pending_test.obj $(TEST_OBJS) \
		hash.obj \
		ignore.obj \
		pending.obj \
		expflags.obj \
		opendir.obj \
		cfg.obj \
		time.obj \
		string.obj \
		stream_win.obj \
		stream.obj \
		log.obj \
		FileDescriptor.obj \
		PubSub.obj \
		FileInformation.obj \
		tests\log_stub.obj \
		winbuild\pathmap.obj \
		winbuild\mkdir.obj \
		winbuild\dir.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\bser.exe: tests\bser.obj bser.obj $(TEST_OBJS) \
	tests\log_stub.obj  \
	string.obj \
	hash.obj \
	PubSub.obj \
	log.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\cache.exe: tests\CacheTest.obj $(TEST_OBJS) \
	tests\log_stub.obj  \
	string.obj \
	hash.obj \
	PubSub.obj \
	ThreadPool.obj \
	log.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\future.exe: tests\FutureTest.obj $(TEST_OBJS) \
	tests\log_stub.obj  \
	string.obj \
	hash.obj \
	PubSub.obj \
	ThreadPool.obj \
	log.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\result.exe: tests\ResultTest.obj $(TEST_OBJS) \
	tests\log_stub.obj  \
	string.obj \
	hash.obj \
	PubSub.obj \
	log.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\childproc.exe: tests\childproc.obj $(TEST_OBJS) \
	tests\log_stub.obj  \
	ChildProcess.obj \
	winbuild\posix_spawn.obj \
	winbuild\pathmap.obj \
	Pipe.obj \
	FileDescriptor.obj \
	FileInformation.obj \
	string.obj \
	stream_win.obj \
	hash.obj \
	PubSub.obj \
	log.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\log.exe: tests\log.obj log.obj $(TEST_OBJS) \
	PubSub.obj \
	string.obj \
	hash.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

tests\wildmatch_test.exe: tests\wildmatch_test.obj $(TEST_OBJS) \
	tests\log_stub.obj  \
	PubSub.obj \
	string.obj \
	hash.obj \
	log.obj
	@echo LINK $@
	$(LINKER) $** $(LIBS)

dist:
	-mkdir Watchman
	copy watchman.exe Watchman
	copy watchman.pdb Watchman
	copy LICENSE Watchman\LICENSE.txt
	copy README.markdown Watchman

clean:
	-del $(OBJS) $(TEST_OBJS) $(TEST_DIR_OBJS) *.exe

distclean: clean

=== debian/changelog ===
watchman (4.9.0-8build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Wed, 05 Mar 2025 01:18:37 +0000

watchman (4.9.0-8) unstable; urgency=medium

  * QA Upload
  * Use dh-sequence-python3
  * Add build-dep on python3-setuptools (Closes: #1080829)

 -- Alexandre Detiste <tchet@debian.org>  Sun, 19 Jan 2025 21:23:12 +0100

watchman (4.9.0-7) unstable; urgency=medium

  * Bumped up standards version. 
  * Fix issue with Python 3.10, patch by Frederic Peters (Closes: #1008964)
  * Removed unnecessary lintian overrides
  * Added reproducibility flags
  * Orphaning package and setting maintainer to Debian QA

 -- Anuradha Weeraman <anuradha@debian.org>  Sat, 10 Sep 2022 16:25:54 +0530

watchman (4.9.0-6) unstable; urgency=high

  * Fix FTBFS with autoconf 2.71 (Closes: #978921)
  * Bumped up Standards Version to 4.6.0

 -- Anuradha Weeraman <anuradha@debian.org>  Tue, 24 Aug 2021 20:15:54 +0530

watchman (4.9.0-5) unstable; urgency=high

  [ Debian Janitor ]
  * Use secure URI in Homepage field.
  * Remove obsolete field Name from debian/upstream/metadata (already present in
    machine-readable debian/copyright).

  [ Anuradha Weeraman ]
  * Resolve FTBFS due to version constraint on python3-all-dev (Closes: #975746)
  * Bumped up standards version

 -- Anuradha Weeraman <anuradha@debian.org>  Wed, 25 Nov 2020 19:03:07 -0500

watchman (4.9.0-4) unstable; urgency=medium

  * Bumped up standards version
  * Included upstream metadata
  * Enabled reproducibility testing in the Salsa CI pipeline
  * Lintian fixes
  * Fix for auto-upperlimit-python3 transition

 -- Anuradha Weeraman <aweeraman@gmail.com>  Sat, 01 Feb 2020 18:09:00 -0500

watchman (4.9.0-3) unstable; urgency=medium

  * Respect TMPDIR for state (Closes: #946544)

 -- Anuradha Weeraman <aweeraman@gmail.com>  Tue, 31 Dec 2019 17:12:19 -0500

watchman (4.9.0-2) unstable; urgency=low

  * Bumped up standards version
  * Build python modules for all supported python3 versions

 -- Anuradha Weeraman <aweeraman@gmail.com>  Mon, 11 Nov 2019 16:02:18 -0500

watchman (4.9.0-1) unstable; urgency=low

  * Initial release. Closes: #740691

 -- Anuradha Weeraman <aweeraman@gmail.com>  Wed, 02 Oct 2019 11:24:37 -0400

=== debian/control ===
Source: watchman
Section: utils
Priority: optional
Maintainer: Debian QA Group <packages@qa.debian.org>
Build-Depends: debhelper (>=12~),
               debhelper-compat (=12),
               dh-sequence-python3,
               python3-all-dev,
               python3-setuptools,
               pkgconf,
               libpcre3-dev,
               libssl-dev
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/debian/watchman
Vcs-Git: https://salsa.debian.org/debian/watchman.git
Homepage: https://facebook.github.io/watchman
Rules-Requires-Root: no

Package: watchman
Architecture: linux-any
Suggests: python3-pywatchman
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: File watching service
 Watchman can be used to watch files and record when they actually change.
 It can be used to trigger actions (such as rebuilding assets) when
 matching files change. If you require to perform an action based on
 whether a file changes or not, watchman may be the tool you need. By
 giving watchman a pattern and an action to take when the files change,
 you can trigger an activity to be taken.

Package: python3-pywatchman
Section: python
Architecture: linux-any
Provides: ${python3:Provides}
Depends: ${misc:Depends}, ${shlibs:Depends}, ${python3:Depends}, watchman
Description: Python library for Watchman and related utilities
 A Python library for watchman (the file watching service), and related
 utilities such as watchman-make and watchman-wait. Watchman can be used
 to watch files and record when they actually change. It can be used
 to trigger actions (such as rebuilding assets) when matching files
 change. If you require to perform an action based on whether a file
 changes or not, watchman may be the tool you need. By giving watchman
 a pattern and an action to take when the files change, you can trigger
 an activity to be taken.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE=1
export PYTHON=python3
export PYBUILD_NAME=pywatchman
export PYBUILD_SYSTEM=distutils
export PYBUILD_VERSIONS=3
export DEB_BUILD_MAINT_OPTIONS = hardening=+all reproducible=+all
export PY3VERSIONS = $(shell py3versions -r)

%:
	dh $@

override_dh_autoreconf:
	dh_autoreconf -- ./autogen.sh

override_dh_auto_configure:
	dh_auto_configure -- --disable-statedir --enable-lenient --with-pcre=/usr/bin/pcre-config

execute_after_dh_auto_build:
	set -ex; for python in $(PY3VERSIONS); do \
		cd python && $$python setup.py build && cd ..; \
	done;

execute_after_dh_auto_install:
	set -ex; for python in $(PY3VERSIONS); do \
		cd python && $$python setup.py install --root=$(CURDIR)/debian/tmp --install-layout=deb && cd ..; \
	done;

# Remove generated files by autogen.sh too (which are usually distributed by upstream)
execute_after_dh_auto_clean:
	rm -rf python/pywatchman.egg-info/
	rm -rf m4/
	rm -f compile ltmain.sh config.guess config.sub install-sh \
		missing depcomp test-driver
	rm -f Makefile.in aclocal.m4 config.h.in configure
